#/**********************************************
#* Execute:
#*>perl ExtractRepres.pl <ligand>.pdb repres_<X>_transform.txt
#* Example:
#*>perl ExtractRepres.pl IAA_L.pdb repres_IAA_complex_transform.txt
#***********************************************/
#$rmspdb=">RMS-".$ARGV[0];
#open (SOL, $pdbhex);
open (SOL, ">RmsRepres.txt");
open (PDBlig, $ARGV[0]);
open (COORD, $ARGV[1]);
@punts = <PDBlig>;
@coord = <COORD>;
close COORD;
#Extreure traslacions i rotacions solucions hex
for($m=12;$m<=$#coord;$m++){       
  $posicio1 = $coord[$m];
  chomp ($posicio1);
  @hex = split (" ", $posicio1);
  $tx = $hex[4];
  $ty = $hex[5];
  $tz = $hex[6];
  $pi = 3.14159265358979;
  $a = $hex[7];
  $b = $hex[8];
  $c = $hex[9];
  $A = (cos($a) * cos($b) * cos($c)) - (sin($a) * sin($c));
  $B = -(cos($a) * cos($b) * sin($c)) - (sin($a) * cos($c));
  $C = cos($a) * sin($b);
  $D = (sin($a) * cos($b) * cos($c)) + (cos($a) * sin($c));
  $E = -(sin($a) * cos($b) * sin($c)) + (cos($a) * cos($c));
  $F = sin($a) * sin($b);
  $G = -(sin($b) * cos($c));
  $H = sin($b) * sin($c);
  $I = cos($b);
  $nSol = $hex[1];
  $mid = $m-11;
  $Pdboutname = ">Sol$nSol"."_Clust$mid".".pdb";
  open (PDBout, $Pdboutname);
#Punts problema.
  $sum= 0;
  $nAtm=0;
  for ($k= 0; $k<$#punts;$k++){
      $posicio2 = $punts[$k];
      chomp ($posicio2);
      $head = substr $posicio2,0,30;
      $tail = substr $posicio2,54,26;
      $atom = substr $posicio2,0,6;
      @xyz = split (" ", substr $posicio2,30,24);
#Rotaci i  Traslaci
      if ($atom eq "ATOM  "){
	  $nAtm++;
	  $x1 = (($xyz[0] * $A) + ($xyz[1] * $B) + ($xyz[2] * $C))+ $tx;
	  $y1 = (($xyz[0] * $D) + ($xyz[1] * $E) + ($xyz[2] * $F))+ $ty;
	  $z1 = (($xyz[0] * $G) + ($xyz[1] * $H) + ($xyz[2] * $I))+ $tz;
      #RMS
	  $x3 = ($xyz[0]-$x1)**2;
	  $y3 = ($xyz[1]-$y1)**2;
	  $z3 = ($xyz[2]-$z1)**2;
	  $sum += $x3 + $y3 + $z3;
	  $salido = sprintf("%s %6.3f %6.3f %6.3f %s\n",$head,$x1,$y1,$z1,$tail);
	  printf PDBout $salido;
      }
  }
#RMS
  close (PDBout);
  $RMS = sqrt($sum/$nAtm);
  #$taula[0][$j] = $j; #solucio
  #$taula[1][$j] = $RMS; #valor_de_RMS
  print SOL "$hex[0]\t$hex[1]\t$hex[2]\t$hex[3]\t$hex[4]\t$hex[5]\t$hex[6]\t$hex[7]\t$hex[8]\t$hex[9]\t$RMS\n";
  #$res{$hex[1]}=$RMS;
}
#foreach(sort {$res{$a} <=> $res{$b}} keys %res)
	#print SOL "$_: $res{$_}\n";

close SOL;

##############################
# Funciones y Procedimientos #
##############################

sub round {
  my ($number, $places) = @_;
  my $sign = ($number < 0) ? '-' : '';
  my $abs = abs($number);

  if($places > 0) {
      $places *= 1;
      return $sign . substr($abs+("0." . "0" x $places . "5"), 0, $places+length(int($abs))+1);
  } else {
      my $p10 = 10**$places;
      return $sign . int($abs/$p10 + 0.5)*$p10;
  }
}
sub sround {
  my ($number, $length, $places) = @_;
  my $sign = ($number < 0) ? '-' : '';
  my $abs = abs($number);
  my $ent = length($sign.int($abs));
  for($i=0;$i<($length-$ent);$i++){
  $sign = " ".$sign;
  }
  if($places > 0) {
      $places *= 1;
      return $sign . substr($abs+("0." . "0" x $places . "5"),0, $places+length(int($abs))+1);
  } else {
      my $p10 = 10**$places;
      return $sign . int($abs/$p10 + 0.5)*$p10;
  }
}

sub bubblesort {
    my $array = $_[0];
    my $num   = $_[1];

    my $i;         # The initial index for the bubbling scan.
    my $j;         # The running index for the bubbling scan.
    my $ncomp = 0; # The number of comparisons.
    my $nswap = 0; # The number of swaps.

    for ( $i = $num-1; $i; $i-- ) { 
        for ( $j = 1; $j <= $i; $j++ ) {
            $ncomp++;
            # Swap if needed.
            if ( $$array[1][ $j - 1 ] < $$array[1][ $j ] ) {
        $n = $$array[1][ $j - 1 ];
        $$array[1][ $j - 1 ] = $$array[1][ $j ];
        $$array[1][ $j ] = $n;
        $n = $$array[0][ $j - 1 ];
        $$array[0][ $j - 1 ] = $$array[0][ $j ];
        $$array[0][ $j ] = $n;
                $nswap++;
            }
        }
    }
}


sub trim {
    my  $str = shift;
    $str =~ s/^\s+//;
    $str =~ s/\s+$//;
    return  $str;

}

