source("preprocessing.R")
source("dbscan.eps.choice.R")
source("DockAnalyse.R")

windows()
windows()
windows()
windows()
windows()
windows()
windows()

# This Flag is 0 (Escher), 1 (Hex) and 2 (Frodock) 
outOrig = 1
marker <- NULL
# marker <- 1 + 100*(0:9)
max.eps <- 1
MinPts <- 15

if(outOrig == 0){
# Example 1. An ESCHER output file
# Format of each line in the file: 
#    Sol. Score   Rms Bumps Chg. Pos. Neg. Apo. Pol. RotX RotY RotZ TransX TransY TransZ
dev.set(8)
aux <- DockAnalyse("<escher_outputfile_name>.sol", 
        num.com.lin=15, 
        pos.trans.coor=c(13,14,15),pos.rot.coor=c(10,11,12),
        pos.score=2, ascending.score=TRUE,
        d.power=1, center="mode",
        col.name=1, max.eps=max.eps, MinPts=MinPts,
        marker=marker,
	  radians=FALSE,
        exclude.noise.cluster=TRUE,
        plot.true=TRUE, print.info=TRUE,outOrig = outOrig)
}


if(outOrig == 1){
# Example 2. A HEX output file
# Format of each line in the file: 
#    Cluster Solution RMS Etotal x y z alpha beta gamma
dev.set(8)
aux <- DockAnalyse("Nfs1_Nfs1_transform.txt", 
        num.com.lin=12, 
        pos.trans.coor=c(5,6,7),pos.rot.coor=c(8,9,10),
        pos.score=4, ascending.score=FALSE,
        d.power=1, center="mode",
        col.name=2,max.eps=max.eps,MinPts=MinPts,
        marker=marker,
	  radians=TRUE,
        exclude.noise.cluster=TRUE,
        plot.true=TRUE, print.info=TRUE, outOrig = outOrig)
}

if(outOrig == 2){
# Example 3. A FroDock output file
# Format of each line in the file: 
#    Cluster Solution RMS Etotal x y z alpha beta gamma
dev.set(8)
aux <- DockAnalyse("<frodock_outputfile_name>.txt",
        num.com.lin=8, 
        pos.trans.coor=c(5,6,7),pos.rot.coor=c(2,3,4),
        pos.score=8, ascending.score=FALSE,
        d.power=1, center="mode",
        col.name=1,max.eps=max.eps,MinPts=MinPts,
        marker=marker,
	  radians=FALSE,
        exclude.noise.cluster=FALSE,
        plot.true=TRUE, print.info=TRUE, outOrig = outOrig)
}


